"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mac = __importStar(require("./mac"));
var win = __importStar(require("./win"));
var agent = /^win/.test(process.platform) ? win : mac;
function execute(fn) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return new Promise(function (resolve, reject) {
        var _a;
        var ret = (_a = agent)[fn].apply(_a, args);
        if (ret.status) {
            reject(ret.stdout);
        }
        else {
            resolve(ret.stdout);
        }
    });
}
function enable(hostname, port, protocol) {
    return execute('enable', hostname, port, protocol);
}
exports.enable = enable;
function disable() {
    return execute('disable');
}
exports.disable = disable;
function status() {
    return execute('status');
}
exports.status = status;
exports.default = {
    status: status,
    enable: enable,
    disable: disable,
};
