"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var exec_sync_1 = require("./exec-sync");
var networkType;
function getNetworkType() {
    if (networkType) {
        return networkType;
    }
    var networkTypes = [
        'Ethernet',
        'Thunderbolt Ethernet',
        'Wi-Fi',
    ];
    for (var _i = 0, networkTypes_1 = networkTypes; _i < networkTypes_1.length; _i++) {
        var type = networkTypes_1[_i];
        var result = exec_sync_1.execSync("networksetup -getwebproxy " + type);
        if (result.status === 0) {
            networkType = type;
            return networkType;
        }
    }
    throw new Error('Unknown network type');
}
function status() {
    var networkType = getNetworkType();
    return exec_sync_1.execSync("networksetup -getwebproxy " + networkType);
}
exports.status = status;
function enable(hostname, port, proxyType) {
    if (proxyType === void 0) { proxyType = 'http'; }
    var networkType = getNetworkType();
    var cmd = proxyType === 'https'
        ? 'setsecurewebproxy'
        : 'setwebproxy';
    var bypass = "networksetup -setproxybypassdomains " + networkType + " 127.0.0.1 localhost";
    return exec_sync_1.execSync("networksetup -" + cmd + " " + networkType + " " + hostname + " " + port + " && " + bypass);
}
exports.enable = enable;
function disable(proxyType) {
    if (proxyType === void 0) { proxyType = 'http'; }
    var networkType = getNetworkType();
    var cmd = proxyType === 'https'
        ? 'setsecurewebproxystate'
        : 'setwebproxystate';
    return exec_sync_1.execSync("networksetup -" + cmd + " " + networkType + " off");
}
exports.disable = disable;
